<?php

class settings
{
  // Variables
  public $errormessage;
  public $displayerrors; 
  public $displaykeys; 
  public $injecturl;
  
  // Construct the token add
  public function __construct()
  {
    global $_POST, $wpdb;

    $this->init();
  }

  // Initializes the page.
  function init()
  {
    global $_POST, $wpdb, $_SERVER, $current_site, $blog_id;  
    $haserror = false;

    // Create custom vars
    $siteid = $current_site->id;
    $blogid = $blog_id;

    // Process Form
    if(isset($_POST['savesettings']))
    {
      $this->displayerrors = (isset($_POST['displayerrors']) && 
                             !empty($_POST['displayerrors']) && 
                             $_POST['displayerrors']=='1') ? intval($_POST['displayerrors']) : 0; 
      $this->displaykeys = (isset($_POST['displaykeys']) && 
                             !empty($_POST['displaykeys']) && 
                             $_POST['displaykeys']=='1') ? intval($_POST['displaykeys']) : 0;
      $this->injecturl = (isset($_POST['injecturl']) && 
                         !empty($_POST['injecturl']) && 
                         $_POST['injecturl']=='1') ? intval($_POST['injecturl']) : 0; 
 
      // Update the options
      update_option('tokenmanager_displayerrors', $this->displayerrors);
      update_option('tokenmanager_displaykeys', $this->displaykeys);
      update_option('tokenmanager_injecturl', $this->injecturl);

      $this->errormessage = '<span style="color: Green;">Save Settings Completed</span>';
    }
    else
    {
      // Display options because no post back
      $this->displayerrors = intval(get_option('tokenmanager_displayerrors', 0));
      $this->displaykeys = intval(get_option('tokenmanager_displaykeys', 0));
      $this->injecturl = intval(get_option('tokenmanager_injecturl', 0));
    }   
  }
}

// Build class
$settings = new settings();

$_POST = array_map('stripslashes_deep', $_POST);
$_GET = array_map('stripslashes_deep', $_GET);
  
?>

<link rel="stylesheet" type="text/css" href="<?php echo plugin_dir_url( __FILE__ ); ?>tm.css" />

<div class="wrap">
  <div class="icon32 icon32-posts-post" id="icon-edit" style="background: transparent url(<?php echo plugin_dir_url( __FILE__ ); ?>icons/icon1_32.png) 0px 0px no-repeat"><br></div>
  <h2>Token Manager - Settings</h2>
  <p>Main settings for controlling the Token Manager. If you need help, mouseover the question mark icon.</p>
  <form method="POST" action="<?php echo $_SERVER['REQUEST_URI']; ?>">

<?php echo $settings->errormessage; ?>

<table class="form-table">
<tbody>
  <tr class="form-field form-required">
    <th scope="row"><label for="tokenname">Extra Token Info <img alt="Adds extra tokens like url and template path info directly, into the tokens for you." title="Adds extra tokens like url and template path info, directly into the tokens for you." src="<?php echo plugin_dir_url( __FILE__ ) . 'icons/help.png'; ?>" /></label></th>
      <td>
        <input type="radio" <?php echo ($settings->injecturl==1)? ' checked="checked" ' : ''; ?> value="1" name="injecturl">
        <span style="margin: 0px 10px 0px 0px;">Yes</span>
        <input type="radio" <?php echo ($settings->injecturl==0)? ' checked="checked" ' : ''; ?> value="0" name="injecturl">
        <span>No</span>
      </td>
  </tr>
  <tr class="form-field form-required">
    <th scope="row"><label for="tokenname">Display Token Errors <img alt="Turns on error handling and displays error messages on webpage." title="Turns on error handling and displays error messages on webpage." src="<?php echo plugin_dir_url( __FILE__ ) . 'icons/help.png'; ?>" /></label></th>
      <td>
        <input type="radio" <?php echo ($settings->displayerrors==1)? ' checked="checked" ' : ''; ?> value="1" name="displayerrors">
        <span style="margin: 0px 10px 0px 0px;">Yes</span>
        <input type="radio" <?php echo ($settings->displayerrors==0)? ' checked="checked" ' : ''; ?> value="0" name="displayerrors">
        <span>No</span>
      </td>
  </tr>
  <tr class="form-field form-required">
    <th scope="row"><label for="tokenname">Display Token Key Pairs <img alt="Displays all token key pairs in a page. For testing only!" title="Displays all token key pairs in a page. For testing only!" src="<?php echo plugin_dir_url( __FILE__ ) . 'icons/help.png'; ?>" /></label></th>
      <td>
        <input type="radio" <?php echo ($settings->displaykeys==1)? ' checked="checked" ' : ''; ?> value="1" name="displaykeys">
        <span style="margin: 0px 10px 0px 0px;">Yes</span>
        <input type="radio" <?php echo ($settings->displaykeys==0)? ' checked="checked" ' : ''; ?> value="0" name="displaykeys">
        <span>No</span>
      </td>
  </tr>
    <tr>
      <th scope="row"></th>
        <td><input class="button-primary" type="submit" name="savesettings" value="Save Settings" id="savesettings" /></td>
    </tr>
</tbody></table>
</form>
</div>

