<?php

class tokenadd
{
  // Variables
  private $error;
  private $errortokenname;
  private $errortokentype;
  private $errorhtmlvalue;
  private $errordescription;

  private $icon;
  private $tablenametypes;
  private $tablenametokens;

  // Properties
  public function set_error($_value) { $this->error = $_value; } 
  public function get_error() { return $this->error; }
  public function set_errortokentype($_value) { $this->errortokentype = $_value; } 
  public function get_errortokentype() { return $this->errortokentype; }
  public function set_errortokenname($_value) { $this->errortokenname = $_value; } 
  public function get_errortokenname() { return $this->errortokenname; }
  public function set_errorhtmlvalue($_value) { $this->errorhtmlvalue = $_value; } 
  public function get_errorhtmlvalue() { return $this->errorhtmlvalue; }
  public function set_errordescription($_value) { $this->errordescription = $_value; } 
  public function get_errordescription() { return $this->errordescription; }

  public function set_icon($_value) { $this->icon = $_value; } 
  public function get_icon() { return $this->icon; }
  public function set_tablenametypes($_value) { $this->tablenametypes = $_value; } 
  public function get_tablenametypes() { return $this->tablenametypes; }
  public function set_tablenametokens($_value) { $this->tablenametokens = $_value; } 
  public function get_tablenametokens() { return $this->tablenametokens; }

  // Construct the token add
  public function __construct()
  {
    global $_POST, $wpdb;

    $this->set_icon(plugin_dir_url( __FILE__ ) . 'icons/icon1_32.png');
    $this->set_tablenametypes($wpdb->base_prefix . 'tokenmanagertypes'); 
    $this->set_tablenametokens($wpdb->base_prefix . 'tokenmanager');      

    $this->init();
  }

  // Initializes the page.
  function init()
  {
    global $_POST, $wpdb, $_SERVER, $current_site, $blog_id;  
    $haserror = false;

    // Create custom vars
    $siteid = $current_site->id;
    $blogid = $blog_id;

    // Process Form
    if(isset($_POST['addtoken']))
    {
      // Check required.
      if(!isset($_POST['tokentype']) || empty($_POST['tokentype'])){ $haserror = true; $this->set_errortokentype('<span style="color: Red; display: block;">Please add a token type first.</span>'); }
      if(!isset($_POST['tokenname']) || empty($_POST['tokenname'])){ $haserror = true; $this->set_errortokenname('<span style="color: Red; display: block;">Token Name is a required field!</span>'); }
      if(empty($_POST['htmlvalue']) && empty($_POST['cssvalue']) && empty($_POST['jsvalue']) && empty($_POST['phpvalue'])){ $haserror = true; $this->set_errorhtmlvalue('<span style="color: Red; display: block;">Token Value is a required field!</span>'); }
      if(!isset($_POST['description']) || empty($_POST['description'])){ $haserror = true; $this->set_errordescription('<span style="color: Red; display: block;">Description is a required field!</span>'); }

      if(!$haserror)
      {
        $tokenname = mysql_real_escape_string($_POST['tokenname']);
        $tokentype = mysql_real_escape_string($_POST['tokentype']);
        $htmlvalue = mysql_real_escape_string($_POST['htmlvalue']);
        $phpvalue = mysql_real_escape_string($_POST['phpvalue']);
        $cssvalue = mysql_real_escape_string($_POST['cssvalue']);
        $jsvalue = mysql_real_escape_string($_POST['jsvalue']);
        $description = mysql_real_escape_string($_POST['description']);

        $authorid = wp_get_current_user();
        $authorid = $authorid->ID;
        $tablename = $this->get_tablenametokens();
        $tablename2 = $wpdb->base_prefix . 'tokenmanagerpages';

        // Check if type already exists
        $toke = $wpdb->get_var("SELECT count(*) FROM $tablename WHERE tokenname = '$tokenname' AND active='1' AND siteid='$siteid' AND blogid='$blogid' LIMIT 1");

        if($toke>0){ $haserror = true; $this->set_errortokenname('<span style="color: Red; display: block;">Token Name already exists!</span>'); }

        if(!$haserror)
        {
          // Sets the history for the insert
          $remoteip = $_SERVER['REMOTE_ADDR'];
          $occurred = date("D, M j, Y G:i:s T");
          $history = mysql_real_escape_string("<?xml version=\"1.0\" encoding=\"utf-8\" ?>
<tokenmanager>
  <history>
    <event remoteip=\"$remoteip\" dateoccurred=\"$occurred\" author=\"$authorid\" type=\"create\" status=\"Created a new token in the token manager.\"  />
    <!-- NEXT -->
  </history>
</tokenmanager>");

          // Insert into database
          $wpdb->query("INSERT INTO $tablename (id, datecreated, lastupdated, siteid, blogid, tokenname, htmlvalue, phpvalue, cssvalue, jsvalue, description, authorid, typeid, active, version, history) 
                        VALUES (null, UNIX_TIMESTAMP(), UNIX_TIMESTAMP(), '$siteid', '$blogid', '$tokenname', '$htmlvalue', '$phpvalue', '$cssvalue', '$jsvalue', '$description', '$authorid', '$tokentype', '1', '1', '$history')");

          // Get last insert id.
          $id = $wpdb->insert_id;
        }
      }

      if($haserror)
      {
        $this->set_error('<span style="color: Red;">Your form had the following errors!</span>');
      }
      else
      {
        $this->set_error('<span style="color: Green;">New Token Created Successfully!</span>');
 
        // Reset form.
        $_POST['tokenname'] = '';
        $_POST['htmlvalue'] = '';
        $_POST['phpvalue'] = '';
        $_POST['cssvalue'] = '';
        $_POST['jsvalue'] = '';
        $_POST['tokentype'] = '';
        $_POST['description'] = '';
      }
    }
  }

  // Builds the drop downlist
  function build_dropdownlist($_selected)
  {
    global $_POST, $wpdb, $current_site, $blog_id;

    // Create custom vars
    $siteid = $current_site->id;
    $blogid = $blog_id;
    
    // Escape data
    $results = '<select id="tokentype" name="tokentype" style="min-width:220px;">';
    $droplistitems = $wpdb->get_results('SELECT id, tokentype FROM ' . $this->get_tablenametypes() . " WHERE active = 1 AND siteid='$siteid' AND blogid='$blogid' ORDER BY orderof");

    foreach ($droplistitems as $droplistitem) 
    {
      $results .= '<option value="' . $droplistitem->id . '"' . (($_selected==$droplistitem->id)? ' selected="selected"': '')  . '>' . $droplistitem->tokentype . '</option>';
    }

    $results .= '</select>';

    return $results;
  }
}

// Build class
$tokenadd = new tokenadd();

$_POST = array_map('stripslashes_deep', $_POST);
$_GET = array_map('stripslashes_deep', $_GET);
  
?>

<style type="text/css">

.tabholder
{
  margin: 0px 0px 0px 3px;
}

.tabon
{
  cursor: default;
  display: inline-block;
  border-top: solid 1px #DFDFDF;
  border-left: solid 1px #DFDFDF;
  border-right: solid 1px #DFDFDF;
  background: #f3f3f3;
  color: black;
  margin: 0px 1px 0px 0px;
  padding: 5px;
}

.taboff
{
  cursor: pointer;
  display: inline-block;
  border-top: solid 1px #DFDFDF;
  border-left: solid 1px #DFDFDF;
  border-right: solid 1px #DFDFDF;
  background: white;
  color: black;
  margin: 0px 1px 0px 0px;
  padding: 5px;
}

.tabdivon
{
  display: block;
}

.tabdivoff
{
  display: none;
}

</style>

<script type="text/javascript">

function $cls(v, c){ var o = document.getElementById(v); o.setAttribute("class",c); o.setAttribute("className",c); }

function hidetabs()
{
  $cls('tab1', 'taboff');
  $cls('tab2', 'taboff');
  $cls('tab3', 'taboff');
  $cls('tab4', 'taboff');

  $cls('tabdiv1', 'tabdivoff');
  $cls('tabdiv2', 'tabdivoff');
  $cls('tabdiv3', 'tabdivoff');
  $cls('tabdiv4', 'tabdivoff');
}

function showtab(t)
{
  hidetabs();
  $cls('tab' + t, 'tabon');
  $cls('tabdiv' + t, 'tabdivon');
}

</script>

<div class="wrap">
  <div class="icon32 icon32-posts-post" id="icon-edit" style="background: transparent url(<?php echo $tokenadd->get_icon(); ?>) 0px 0px no-repeat"><br></div>
  <h2>Token Manager - Add New Token <a class="add-new-h2" href="admin.php?page=tokenmanager">View All Tokens</a></h2>
  <p>Create a new token in the wordpress token manager.</p>
  <form method="POST" action="<?php echo $_SERVER['REQUEST_URI']; ?>">

<?php echo $tokenadd->get_error(); ?>
<table class="form-table">
<tbody>
  <tr class="form-field form-required">
    <th scope="row"><label for="tokenname">Token Name <span class="description">(required)</span></label></th>
      <td>
        <input type="text" aria-required="true" id="tokenname" name="tokenname" value="<?php echo (isset($_POST['tokenname']) && !empty($_POST['tokenname']))?$_POST['tokenname']:''; ?>">
        <?php echo $tokenadd->get_errortokenname(); ?>
      </td>
  </tr>
  <tr class="form-field form-required">
    <th scope="row"><label for="tokentype">Token Type</label></th>
      <td><?php echo $tokenadd->build_dropdownlist((isset($_POST['tokentype']) && !empty($_POST['tokentype']))?$_POST['tokentype']:''); ?> ( <a href="admin.php?page=tokenmanageraddtype">Add New Type</a> )
          <?php echo $tokenadd->get_errortokentype(); ?></td>
    </tr>
    <tr class="form-field form-required">
      <th scope="row"><label for="description">Token Description <span class="description">(required)</span></label></th>
        <td>
          <textarea id="description" name="description" rows="6"><?php echo (isset($_POST['description']) && !empty($_POST['description']))?$_POST['description']:''; ?></textarea>
          <?php echo $tokenadd->get_errordescription(); ?>
        </td>
    </tr>
    <tr class="form-field form-required">
      <th scope="row"><label for="tokenvalue">Token Value <span class="description">(required)</span></label></th>
        <td>
          <div class="tabholder">
          <span id="tab1" class="tabon" onclick="showtab(1);">HTML</span><span id="tab2" class="taboff" onclick="showtab(2);">PHP</span><span id="tab3" class="taboff" onclick="showtab(3);">CSS</span><span id="tab4" class="taboff" onclick="showtab(4);">JS</span>
          </div>
          <div id="tabdiv1" class="tabdivon">
            <textarea id="htmlvalue" name="htmlvalue" rows="30"><?php echo (isset($_POST['htmlvalue']) && !empty($_POST['htmlvalue']))?$_POST['htmlvalue']:''; ?></textarea>
            <?php echo $tokenadd->get_errorhtmlvalue(); ?>
          </div>
          <div id="tabdiv2" class="tabdivoff">
            <textarea id="phpvalue" name="phpvalue" rows="30"><?php echo (isset($_POST['phpvalue']) && !empty($_POST['phpvalue']))?$_POST['phpvalue']:''; ?></textarea>
          </div>
          <div id="tabdiv3" class="tabdivoff">
            <textarea id="cssvalue" name="cssvalue" rows="30"><?php echo (isset($_POST['cssvalue']) && !empty($_POST['cssvalue']))?$_POST['cssvalue']:''; ?></textarea>
          </div>
          <div id="tabdiv4" class="tabdivoff">
            <textarea id="jsvalue" name="jsvalue" rows="30"><?php echo (isset($_POST['jsvalue']) && !empty($_POST['jsvalue']))?$_POST['jsvalue']:''; ?></textarea>
          </div>

        </td>
    </tr>
    <tr>
      <th scope="row"></th>
        <td><input class="button-primary" type="submit" name="addtoken" value="Add Token" id="submitbutton" /></td>
    </tr>
</tbody></table>
</form>
</div>

