<?php

// Add paging class
include_once("paging.php");

class tokentypes
{
  // Variables
  private $js;
  private $icon;
  private $tablenametypes;
  private $tablenametokens;

  // Properties
  public function set_js($_value) { $this->js = $_value; } 
  public function get_js() { return $this->js; }
  public function set_icon($_value) { $this->icon = $_value; } 
  public function get_icon() { return $this->icon; }
  public function set_tablenametypes($_value) { $this->tablenametypes = $_value; } 
  public function get_tablenametypes() { return $this->tablenametypes; }
  public function set_tablenametokens($_value) { $this->tablenametokens = $_value; } 
  public function get_tablenametokens() { return $this->tablenametokens; }

  // Construct the token add
  public function __construct()
  {
    global $_POST, $wpdb;

    $this->set_js('');
    $this->set_icon(plugin_dir_url( __FILE__ ) . 'icons/icon1_32.png');
    $this->set_tablenametypes($wpdb->base_prefix . 'tokenmanagertypes'); 
    $this->set_tablenametokens($wpdb->base_prefix . 'tokenmanager');      

    $this->init();
  }

  // Initializes the page.
  function init()
  {
    global $_POST, $wpdb, $current_site, $blog_id;

    // Create custom vars
    $siteid = $current_site->id;
    $blogid = $blog_id;

    if(isset($_POST['typeidforce']) && !empty($_POST['typeidforce']))
    {
      $tid = $_POST['typeidforce'];
      $tablename1 = $wpdb->base_prefix . 'tokenmanager';
      $tablename2 = $wpdb->base_prefix . 'tokenmanagertypes';
      $tablename3 = $wpdb->base_prefix . 'tokenmanagerpages';
      $wpdb->query("DELETE FROM $tablename3 a LEFT JOIN $tablename1 b on a.tokenid = b.id WHERE b.typeid = '$tid' AND a.siteid='$siteid' AND a.blogid='$blogid';");
      $wpdb->query("UPDATE $tablename1 SET active = 0 WHERE typeid = '$tid' AND siteid='$siteid' AND blogid='$blogid';");
      $wpdb->query("UPDATE $tablename2 SET active = 0 WHERE id = '$tid' AND siteid='$siteid' AND blogid='$blogid';");
    }

    // Process Form
    if(isset($_POST['typeid']) && !empty($_POST['typeid']))
    {
      $tid = $_POST['typeid'];
      $tablename1 = $wpdb->base_prefix . 'tokenmanager';
      $tablename2 = $wpdb->base_prefix . 'tokenmanagertypes';

      // Check if type still exists
      $type = $wpdb->get_var("SELECT count(*) FROM $tablename1 WHERE active = 1 AND typeid = '$tid' AND siteid='$siteid' AND blogid='$blogid';");

      if($type==0)
      {
        $wpdb->query("UPDATE $tablename2 SET active = 0 WHERE id = '$tid' AND siteid='$siteid' AND blogid='$blogid';");
      }
      else
      {
        
        $this->set_js("<script type=\"text/javascript\">
             function confirmdeleteforce()
             {
                 var answer = confirm(\"Token Type ($tid) has $type associated token(s). Force remove all associated tokens, also?!\")
                 if (answer)
                 {
                   document.getElementById('typeidforce').value=$tid; 
                   document.getElementById('myfrom').submit();
                 }
             }
             confirmdeleteforce();
             </script>");
      }
    }
  }

  // Initializes the page.
  function build_grid()
  {
    global $_POST, $wpdb, $current_site, $blog_id;

    // Create custom vars
    $siteid = $current_site->id;
    $blogid = $blog_id;  
   
    $tablename1 = $this->get_tablenametypes();
    $tablename2 = $wpdb->base_prefix . 'users';

    // Get the filter add %% to escape or wont work with prepare
    $filt = '';
    if(isset($_GET['filt']) && !empty($_GET['filt']))
    {
      $filt = mysql_real_escape_string($_GET['filt']);
      $filt = "AND a.tokentype like '%%" . str_replace('}', '', str_replace('{', '', $_GET['filt'])) . "%%'";
    }

    //get the number of records in the database table
    $pagination_count = 0;
    if(!empty($filt))
    {
      $pagination_count = $wpdb->get_var($wpdb->prepare("SELECT count(*)      
                                 FROM $tablename1 a
                                 LEFT JOIN $tablename2 b ON a.authorid = b.ID 
                                 WHERE a.active = 1 $filt"));
    }
    else
    {
      $pagination_count = $wpdb->get_var($wpdb->prepare("SELECT count(*)      
                                 FROM $tablename1 a
                                 LEFT JOIN $tablename2 b ON a.authorid = b.ID 
                                 WHERE a.active = 1"));
    }

    $pge = (isset($_GET['pge']) && !empty($_GET['pge'])) ? $_GET['pge'] : 1;
    $paging = new paging($pge, 25, intval($pagination_count), paging::pageurl());

    $list_end = 25;
    $list_start = $paging->get_rangestart()-1;

    // Escape data
    $results = $results = $paging->render('Find Token Type') . '<table class="widefat">
                <thead><tr><th></th><th></th><th></th><th></th><th>Type ID</th><th>Token Type</th><th></th><th></th></tr></thead>
                <tfoot><tr><th></th><th></th><th></th><th></th><th>Type ID</th><th>Token Type</th><th></th><th></th></tr></tfoot><tbody>';
    
    if(!empty($filt))
    {
      $items = $wpdb->get_results("SELECT a.id, a.tokentype, FROM_UNIXTIME(a.datecreated) as datecreated, FROM_UNIXTIME(a.lastupdated) as lastupdated,
                                   a.tokendescription as description, b.user_login as author, a.authorid as authorid, a.version as version
                                   FROM $tablename1 a
                                   LEFT JOIN $tablename2 b ON a.authorid = b.ID 
                                   WHERE a.active = 1 AND a.siteid = '$siteid' AND a.blogid = '$blogid' $filt
                                   ORDER BY a.datecreated DESC LIMIT $list_start, $list_end");
    }
    else
    {
      $items = $wpdb->get_results("SELECT a.id, a.tokentype, FROM_UNIXTIME(a.datecreated) as datecreated, FROM_UNIXTIME(a.lastupdated) as lastupdated,
                                   a.tokendescription as description, b.user_login as author, a.authorid as authorid, a.version as version
                                   FROM $tablename1 a
                                   LEFT JOIN $tablename2 b ON a.authorid = b.ID 
                                   WHERE a.active = 1 AND a.siteid = '$siteid' AND a.blogid = '$blogid'
                                   ORDER BY a.datecreated DESC LIMIT $list_start, $list_end");
    }

    $alt = true;

    foreach ($items as $item) 
    {
      $alt = ($alt)? false : true;
      $alttext = ($alt) ? 'alternate' : '';
      $id = $item->id;
      $tokentype = $item->tokentype;
      $datecreated = $item->datecreated;
      $lastupdated = $item->lastupdated;
      $description = $item->description;
      $author = $item->author;
      $authorid = $item->authorid;
      $version = $item->version;
      $results .= "<tr class=\"" . $alttext . "\">
                   <td style=\"width: 16px; cursor: pointer;\"><a href=\"admin.php?page=tokenmanagertypeedit&tid=$id\"><img src=\"" . plugin_dir_url( __FILE__ )  . "icons/edit.png\" alt=\"Edit Type ($id)\" title=\"Edit Type ($id)\" /></a></td>
                   <td style=\"width: 16px;\"><img src=\"" . plugin_dir_url( __FILE__ )  . "icons/stats.png\" alt=\"Date Created: $datecreated  |  Last Updated: $lastupdated\" title=\"Date Created: $datecreated  |  Last Updated: $lastupdated\" /></td>
                   <td style=\"width: 16px; cursor: pointer;\"><a href=\"user-edit.php?user_id=$authorid\"><img src=\"" . plugin_dir_url( __FILE__ )  . "icons/user.png\" alt=\"Created By: $author ($authorid)\" title=\"Created By: $author ($authorid)\" /></a></td>
                   <td style=\"width: 16px;\"><img src=\"" . plugin_dir_url( __FILE__ )  . "icons/description.png\" alt=\"$description\" title=\"$description\" /></td>
                   <td style=\"width: 85px;\">$id</td>
                   <td>$tokentype</td>
                   <td style=\"width: 16px; cursor: pointer;\"><a href=\"javascript:void(0);\"><img src=\"" . plugin_dir_url( __FILE__ )  . "icons/history.png\" alt=\"View History (VER: $version)\" title=\"View History (VER: $version)\" /></a></td>
                   <td style=\"width: 16px; cursor: pointer;\"><a href=\"javascript:void(0);\" onclick=\"confirmdelete($id);\"><img src=\"" . plugin_dir_url( __FILE__ )  . "icons/delete.png\" alt=\"Delete Type ($id)\" title=\"Delete Type ($id)\" /></a></td></tr>";
    }

    $results .= '</tbody></table>' . $paging->render('Find Token Type');

    return $results;
  }
}

// Build class
$tokentypes = new tokentypes();
  
?>

<script type="text/javascript">

function confirmdelete(id)
{
  var answer = confirm("Are you sure you would like to remove type (" + id + ")?")
  if (answer)
  {
    document.getElementById('typeid').value=id; 
    document.getElementById('myfrom').submit();
  }
}

</script>

<div class="wrap">
  <div class="icon32 icon32-posts-post" id="icon-edit" style="background: transparent url(<?php echo $tokentypes->get_icon(); ?>) 0px 0px no-repeat"><br></div>
  <h2>Token Manager - Token Types <a class="add-new-h2" href="admin.php?page=tokenmanageraddtype">Add New Type</a> </h2>
  <p>A list of token types currently listed in the token manager.</p>

<form method="POST" id="myfrom" action="<?php echo $_SERVER['REQUEST_URI']; ?>">
<?php echo $tokentypes->build_grid($_GET['page']); ?>
<input type="hidden" id="typeid" name="typeid" value="" />
<input type="hidden" id="typeidforce" name="typeidforce" value="" />
<?php echo $tokentypes->get_js(); ?>
</form>

</div>
